CBC_ModeBase Class Reference

CBC block cipher mode of operation default implementation. More...

`#include <modes.h>`

Inheritance diagram for CBC_ModeBase:

## Public Member Functions

IV_Requirement | IVRequirement () const
| Minimal requirement for secure IVs.
bool | RequireAlignedInput () const
unsigned int | MinLastBlockSize () const
| Provides the size of the last block.
Public Member Functions inherited from BlockOrientedCipherModeBase
void | UncheckedSetKey (const byte *key, unsigned int length, const NameValuePairs &params)
| Sets the key for this object without performing parameter validation.
unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher.
bool | IsRandomAccess () const
| Determines whether the cipher supports random access.
bool | IsSelfInverting () const
| Determines whether the cipher is self-inverting.
bool | IsForwardTransformation () const
| Determines if the cipher is being operated in its forward direction.
void | Resynchronize (const byte *iv, int length=-1)
| Resynchronize with an IV.
Public Member Functions inherited from CipherModeBase
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
size_t | MinKeyLength () const
| Returns smallest valid key length.
size_t | MaxKeyLength () const
| Returns largest valid key length.
size_t | DefaultKeyLength () const
| Returns default key length.
size_t | GetValidKeyLength (size_t keylength) const
| Returns a valid key length for the algorithm.
bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length.
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
unsigned int | IVSize () const
| Returns length of the IV accepted by this object.
void | SetCipher (BlockCipher &cipher)
| Set external block cipher.
void | SetCipherWithIV (BlockCipher &cipher, const byte *iv, int feedbackSize=0)
| Set external block cipher and IV.
Public Member Functions inherited from SimpleKeyingInterface
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object.
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object.
bool | IsResynchronizable () const
| Determines if the object can be resynchronized.
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs.
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs.
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs.
unsigned int | DefaultIVLength () const
| Provides the default size of an IV.
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV.
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV.
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message.
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object.
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher.
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size.
virtual void | ProcessData (byte *outString, const byte *inString, size_t length)=0
| Encrypt or decrypt an array of bytes.
virtual size_t | ProcessLastBlock (byte *outString, size_t outLength, const byte *inString, size_t inLength)
| Encrypt or decrypt the last block of data.
virtual bool | IsLastBlockSpecial () const
| Determines if the last block receives special processing.
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes.
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes.
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte.
virtual void | Seek (lword pos)
| Seek to an absolute position.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.

## Static Public Member Functions

static const char * | StaticAlgorithmName ()

## Additional Inherited Members

Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0 , RANDOM_IV , UNPREDICTABLE_RANDOM_IV , INTERNALLY_GENERATED_IV , NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...

## Detailed Description

CBC block cipher mode of operation default implementation.

Definition at line 284 of file modes.h.

## Member Function Documentation

## StaticAlgorithmName()

const char * CBC_ModeBase::StaticAlgorithmName | ( |  | ) |

inline static

Definition at line 287 of file modes.h.

## IVRequirement()

IV_Requirement CBC_ModeBase::IVRequirement | ( |  | ) | const

inline virtual

Minimal requirement for secure IVs.

Returns
  the secure IV requirement of the algorithm

Implements CipherModeBase.

Definition at line 289 of file modes.h.

## RequireAlignedInput()

bool CBC_ModeBase::RequireAlignedInput | ( |  | ) | const

inline

Definition at line 290 of file modes.h.

## MinLastBlockSize()

unsigned int CBC_ModeBase::MinLastBlockSize | ( |  | ) | const

inline virtual

Provides the size of the last block.

Returns
  the minimum size of the last block

MinLastBlockSize() returns the minimum size of the last block. 0 indicates the last block is not special.

MandatoryBlockSize() enlists one of two behaviors. First, if MandatoryBlockSize() returns 1, then the cipher can be streamed and ProcessData() is called with the tail bytes. Second, if MandatoryBlockSize() returns non-0, then the string of bytes is padded to MandatoryBlockSize() according to the padding mode. Then, ProcessData() is called with the padded string of bytes.

Some authenticated encryption modes are not expressed well with MandatoryBlockSize() and MinLastBlockSize(). For example, AES/OCB uses 16-byte blocks (MandatoryBlockSize = 16) and the last block requires special processing (MinLastBlockSize = 0). However, 0 is a valid last block size for OCB and the special processing is custom padding, and not standard PKCS padding. In response an unambiguous IsLastBlockSpecial() was added.

See also
  ProcessData, ProcessLastBlock, MandatoryBlockSize, MinLastBlockSize, BlockPaddingSchemeDef, IsLastBlockSpecial

Reimplemented from StreamTransformation.

Definition at line 291 of file modes.h.

The documentation for this class was generated from the following file:

- modes.h